//ZZ_Peaks_Lawns   Copyright  2009, Arshad Qureshi 
#property copyright "Copyright  2009, Arshad Qureshi. ArshadFX"

extern string zz = "----------- Parameters of DT_ZZ ";
extern int        ExtDepth          =10;     // parameter of "DT_ZZ"
extern int        LookBk_PekVly     =10;
extern string Drawing = "-------------Drawing ";
extern int        Numb_PekLwn       =1;   // 1=ZZ numbers, 2=Price, 3=Peaks number/Lawn numbers

string msg="No Message";

// GV for ZIG ZAG values and new levels flag ------------------------------------------------------
double zzp[], hp[], lp[];                                   // ZZprice, HighPrice, LowPrice
int zzi[], hi[], li[];                                      // ZZindex, HighIndex, LowIndex

// GV for Tradnig Flags ---------------------------------------------------------------------------
bool up=0, dn=0; 

// Init and Dinit functions -----------------------------------------------------------------------
int init()
   {
   ArrayResize(zzp,LookBk_PekVly+1); ArrayResize(zzi,LookBk_PekVly+1); 
   ArrayResize(hp,(LookBk_PekVly/2)+1); ArrayResize(hi,(LookBk_PekVly/2)+1); 
   ArrayResize(lp,(LookBk_PekVly/2)+1); ArrayResize(li,(LookBk_PekVly/2)+1); 
   Alert("AraySizes   zzp[",ArraySize(zzp),"]","    hp[",ArraySize(hp),"]","    lp[",ArraySize(lp),"]");
   return(0);
   }   
int deinit()   {return(0);}

// expert start function --------------------------------------------------------------------------
int start()
   { 
   int count = 0;
   for(int i = 0 ; i<Bars ; i++)
      {  // cycle for getting values of ZZ
      double zz = iCustom(Symbol(),0,"DT_ZZ",ExtDepth,0,i);
      if (zz != 0) 
         {
         zzp[count]=zz;   zzi[count]=i;
         if (count==LookBk_PekVly){break;}
         count++;
         }
      }
   if (Numb_PekLwn==1)  {dZZ_no();}
   if (Numb_PekLwn==2)  {dPrice();}
   

   Comment  (msg
              ,"\nzzp[3] : ",zzp[3],", zzp[2] : ",zzp[2],", zzp[1] : ",zzp[1],", zzp[0] : ",zzp[0]
              ,"\nzzi[3] : ",zzi[3],", zzi[2] : ",zzi[2],", zzi[1] : ",zzi[1],", zzi[0] : ",zzi[0]
            );

   return(0);
  } // exit of start function
// end of expert start function -------------------------------------------------------------------
























void dZZ_no ()       // Draw ZZ numbers on peaks and lawns
   {
   int x=ArraySize(zzi);     // loop cycle
   if (x>1) {
            while (x>0)
               {
               ObjectDelete("H"+x); 
               x--;
               ObjectDelete("L"+x);
               x--;
               }
            }
   if (zzp[1] > zzp[0])  // static leg is UP        
      {msg="zzp[1] > zzp[0])  // static leg is UP ";
      for (x=1; x<ArraySize(zzi); x++)      // loop for creating numbers
         {
         ObjectCreate("H"+x, OBJ_TEXT, 0, Time[zzi[x]],High[zzi[x]]+8*Point ); 
         ObjectSetText("H"+x, ""+x, 12, "Arial", White);
         x++;
         ObjectCreate("L"+x, OBJ_TEXT, 0, Time[zzi[x]],Low[zzi[x]]-1*Point ); 
         ObjectSetText("L"+x, ""+x, 12, "Arial", White);
         }
      }
   if (zzp[1] < zzp[0])  // static leg is DN        
      {msg="zzp[1] < zzp[0])  // static leg is DN ";
      for (x=1; x<ArraySize(zzi); x++)      // loop for creating numbers
         {
         ObjectCreate("H"+x, OBJ_TEXT, 0, Time[zzi[x]],Low[zzi[x]]-1*Point ); 
         ObjectSetText("H"+x, ""+x, 12, "Arial", White);
         x++;
         ObjectCreate("L"+x, OBJ_TEXT, 0, Time[zzi[x]],High[zzi[x]]+8*Point ); 
         ObjectSetText("L"+x, ""+x, 12, "Arial", White);
         }
      }
   }


   
void dPrice ()       // Draw ZZ price on peaks & lawns
   {
   int x=ArraySize(zzi);     // loop cycle
   if (x>1) {
            while (x>0)
               {
               ObjectDelete("H"+x); 
               x--;
               ObjectDelete("L"+x);
               x--;
               }
            }
   if (zzp[1] > zzp[0])  // static leg is UP        
      {
      for (x=1; x<ArraySize(zzi); x++)      // loop for creating numbers
         {
         ObjectCreate("H"+x, OBJ_TEXT, 0, Time[zzi[x]],High[zzi[x]]+8*Point ); 
         ObjectSetText("H"+x, ""+DoubleToStr(zzp[x],Digits), 9, "Arial", White);
         x++;
         ObjectCreate("L"+x, OBJ_TEXT, 0, Time[zzi[x]],Low[zzi[x]]-1*Point ); 
         ObjectSetText("L"+x, ""+DoubleToStr(zzp[x],Digits), 9, "Arial", White);
         }
      }
   if (zzp[1] < zzp[0])  // static leg is DN        
      {
      for (x=1; x<ArraySize(zzi); x++)      // loop for creating numbers
         {
         ObjectCreate("H"+x, OBJ_TEXT, 0, Time[zzi[x]],Low[zzi[x]]-1*Point ); 
         ObjectSetText("H"+x, ""+DoubleToStr(zzp[x],Digits), 9, "Arial", White);
         x++;
         ObjectCreate("L"+x, OBJ_TEXT, 0, Time[zzi[x]],High[zzi[x]]+8*Point ); 
         ObjectSetText("L"+x, ""+DoubleToStr(zzp[x],Digits), 9, "Arial", White);
         }
      }
   }
   
   
   
   

